# OpenEmbedded Kickstart (`.wks`) Reference

## Introduction

The current Wic implementation supports only the basic kickstart partitioning commands: `partition` (or `part` for short) and `bootloader`.

Future updates will implement more commands and options. If you use anything that is not specifically supported, results can be unpredictable.

This chapter provides a reference on the available kickstart commands. The information lists the commands, their syntax, and meanings. Kickstart commands are based on the Fedora kickstart versions but with modifications to reflect Wic capabilities. You can see the original documentation for those commands at the following links:

- http://fedoraproject.org/wiki/Anaconda/Kickstart#part_or_partition

- http://fedoraproject.org/wiki/Anaconda/Kickstart#bootloader

## Command: part or partition

Either of these commands create a partition on the system and use the following syntax:

         part [mntpoint]
         partition [mntpoint]

If you do not provide mntpoint, Wic creates a partition but does not mount it.

The `mntpoint` is where the partition will be mounted and must be of one of the following forms:

- `/path`: For example, "/", "/usr", or "/home"

- `swap`: The created partition is used as swap space.

Specifying a mntpoint causes the partition to automatically be mounted. Wic achieves this by adding entries to the filesystem table (fstab) during image generation. In order for wic to generate a valid fstab, you must also provide one of the `--ondrive`, `--ondisk`, or `--use-uuid` partition options as part of the command. Here is an example using "/" as the mountpoint. The command uses "--ondisk" to force the partition onto the `sdb` disk:

         part / --source rootfs --ondisk sdb --fstype=ext3 --label platform --align 1024

Here is a list that describes other supported options you can use with the `part` and `partition` commands:

- `--size`: The minimum partition size in MBytes. Specify an integer value such as 500. Do not append the number with "MB". You do not need this option if you use `--source`.

- `--source`: This option is a Wic-specific option that names the source of the data that populates the partition. The most common value for this option is "rootfs", but you can use any value that maps to a valid source plug-in. For information on the source plug-ins, see the "Wic Plug-Ins Interface" section.

  If you use `--source rootfs`, Wic creates a partition as large as needed and to fill it with the contents of the root filesystem pointed to by the `-r` command-line option or the equivalent rootfs derived from the `-e` command-line option. The filesystem type used to create the partition is driven by the value of the `--fstype` option specified for the partition. See the entry on `--fstype` that follows for more information.

  If you use `--source plugin-name`, Wic creates a partition as large as needed and fills it with the contents of the partition that is generated by the specified plug-in name using the data pointed to by the `-r` command-line option or the equivalent rootfs derived from the `-e` command-line option. Exactly what those contents and filesystem type end up being are dependent on the given plug-in implementation.

  If you do not use the `--source` option, the `wic` command creates an empty partition. Consequently, you must use the `--size` option to specify the size of the empty partition.

- `--ondisk` or `--ondrive`: Forces the partition to be created on a particular disk.

- `--fstype`: Sets the file system type for the partition. Valid values are:

  - `ext4`

  - `ext3`

  - `ext2`

  - `btrfs`

  - `squashfs`

  - `swap`

- `--fsoptions`: Specifies a free-form string of options to be used when mounting the filesystem. This string will be copied into the `/etc/fstab` file of the installed system and should be enclosed in quotes. If not specified, the default string is "defaults".

- `--label label`: Specifies the label to give to the filesystem to be made on the partition. If the given label is already in use by another filesystem, a new label is created for the partition.

- `--active`: Marks the partition as active.

- `--align (in KBytes)`: This option is a Wic-specific option that says to start a partition on an x KBytes boundary.

- `--no-table`: This option is a Wic-specific option. Using the option reserves space for the partition and causes it to become populated. However, the partition is not added to the partition table.

- `--extra-space`: This option is a Wic-specific option that adds extra space after the space filled by the content of the partition. The final size can go beyond the size specified by the `--size` option. The default value is 10 Mbytes.

- `--overhead-factor`: This option is a Wic-specific option that multiplies the size of the partition by the option's value. You must supply a value greater than or equal to "1". The default value is "1.3".

- `--part-type`: This option is a Wic-specific option that specifies the partition type globally unique identifier (GUID) for GPT partitions. You can find the list of partition type GUIDs at .

- `--use-uuid`: This option is a Wic-specific option that causes Wic to generate a random GUID for the partition. The generated identifier is used in the bootloader configuration to specify the root partition.

- `--uuid`: This option is a Wic-specific option that specifies the partition UUID.

## Command: bootloader

This command specifies how the bootloader should be configured and supports the following options:

Bootloader functionality and boot partitions are implemented by the various `--source` plug-ins that implement bootloader functionality. The bootloader command essentially provides a means of modifying bootloader configuration.

- `--timeout`: Specifies the number of seconds before the bootloader times out and boots the default option.

- `--append`: Specifies kernel parameters. These parameters will be added to the syslinux `APPEND` or `grub` kernel command line.

- `--configfile`: Specifies a user-defined configuration file for the bootloader. You can provide a full pathname for the file or a file that exists in the `canned-wks` folder. This option overrides all other bootloader options.